<?php
/*
Plugin Name: TGN Embed everything
Plugin URI: http://www.thewpwiki.com/embed-everything
Description: All-in-one embed any PDF, YouTube, Google Doc, PowerPoint, Spreadsheet and many more inline your WordPress posts. Want to embed something more? Contact the author!

Author: George Vanous <george@thegamenet.com>
Version: 1.0.0
Author URI: http://www.thewpwiki.com/
*/

define('tgn_defaultWidth', '604');

function tgn_ckfinder_shortcode($values)
{
	extract(tgn_parse_shortcode(array(
		'width' => '100%',
		'height' => '500',
	), $values));

	return tgn_ckfinder_script($width, $height);
}

add_shortcode('ckfinder', 'tgn_ckfinder_shortcode');


function tgn_view_shortcode($values)
{
	extract(tgn_parse_shortcode(array(
		'file' => 'http://tgnfile.com/thegamenet-executive-summary.pdf',
		'width' => tgn_defaultWidth,
		'height' => 600,
	), $values));

	return tgn_google_docs_viewer_iframe($file, $width, $height);
}

add_shortcode('view', 'tgn_view_shortcode');


function tgn_videoreadr_shortcode($values)
{
	extract(tgn_parse_shortcode(array(
		'id' => 'I1uezBsE',
		'width' => tgn_defaultWidth,
		'height' => '560',
		'background' => 'black',
	), $values));

	return tgn_videoreadr_script($id, $width, $height, $background);
}

add_shortcode('videoreadr', 'tgn_videoreadr_shortcode');


function tgn_youtube_shortcode($values)
{
//return('<pre>' . print_r($values, true) . ' - ' . print_r(tgn_parse_shortcode(array('id' => 'X8gBdsBjpJw', 'width' => '604', 'height' => '364'), $values), true) . '</pre>');

	extract(tgn_parse_shortcode(array(
		'id' => 'X8gBdsBjpJw',
		'width' => tgn_defaultWidth,
		'height' => '364',
	), $values));

	return tgn_youtube_object($id, $width, $height);
}

add_shortcode('youtube', 'tgn_youtube_shortcode');


function tgn_embed_everything_head()
{
	// videoreadr

  // temporary patch to size videos to their correct height
	echo <<<EOS
<style type="text/css">
.layout_transcript2 .l_left { height:371px !important }
.layout_transcript2 .l_transcript { top:371px !important }
</style>
EOS;
}

add_action('wp_head', 'tgn_embed_everything_head');


//==============================================================================
// CKFinder
// ckfinder.com
// File manager, functional free demo (demo notice, cannot drag-and-drop files), $59 per-domain license, $590 per-company license
//

function tgn_ckfinder_script($width, $height)
{
	$siteurl = get_option('siteurl');

  return <<<EOS
<div id="ckfinder"></div>

<script type="text/javascript" src="$siteurl/wp-content/plugins/ckeditor-for-wordpress/ckfinder/ckfinder.js"></script>
<script type="text/javascript">

(function()
{
	var config = {};

	// Always use 100% width and height when nested using this middle page.
	config.width = '$width';
	config.height = '$height';

	var ckfinder = new CKFinder(config);
	ckfinder.replace('ckfinder', config);
})();

</script>
EOS;
}

function tgn_ckfinder_iframe($id, $width, $height)
{
	$siteurl = get_option('siteurl');

	return <<<EOS
<iframe src="$siteurl/wp-content/plugins/ckeditor-for-wordpress/ckfinder/ckfinder.html" width="$width" height="$height" scrolling="no" marginheight="0" marginwidth="0" frameborder="0"></iframe>
EOS;
}


//==============================================================================
// Google docs viewer
// http://docs.google.com/viewer
// Supports doc, pdf, ppt, tiff (no Flash or PDF browser plugins required)
// Also supports some docx, pptx (only way to know is to test yours and see if it displays)

function tgn_google_docs_viewer_iframe($url, $width, $height)
{
	$url = urlEncode($url);

	return <<<EOS
<iframe src="http://docs.google.com/viewer?url=$url&embedded=true" width="$width" height="$height" style="border:0"></iframe>
EOS;
}


//==============================================================================
// YouTube
// youtube.com
// Broadcast yourself
//

function tgn_youtube_object($id, $width, $height)
{
  $youtubeId = tgn_youtube_parseUrl($id);

  return <<<EOS
<object width="$width" height="$height">
	<param name="movie" value="http://www.youtube.com/v/$youtubeId?fs=1&amp;hl=en_US"></param>
	<param name="allowFullScreen" value="true"></param>
	<param name="allowscriptaccess" value="always"></param>
	<embed src="http://www.youtube.com/v/$youtubeId?fs=1&amp;hl=en_US" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="$width" height="$height"></embed>
</object>
EOS;
}

function tgn_youtube_parseUrl($url)
{
	preg_match('@(?:\?v=|/v/)([-\w]+)|([-\w]+)$@', $url, $matches);
	return $matches[ count($matches) - 1 ];

//	$values = parse_url( $url, PHP_URL_QUERY );
//	parse_str($values);

//	if (isSet($v))
//	{
//		return $v;
//	}

//	return 'not found';
}

//function parseYouTubeId_test()
//{
// jzNmX69h_HA
// http://www.youtube.com/watch?v=jzNmX69h_HA
// http://www.youtube.com/watch?v=jzNmX69h_HA&feature=player_embedded
// http://www.youtube.com/v/jzNmX69h_HA?fs=1&amp;hl=en_US
// http://www.youtube.com/tgnDragonAge2#p/u/0/jzNmX69h_HA
// http://www.youtube.com/tgnWorldOfWarcraft#p/c/FD3ACB6A1128406A/3/ZXKobFJWuyc
//
//	$s = 'jzNmX69h_HA';
//	echo parseYouTubeId($s);
//	echo '<br><br>';
//
//	$s = 'http://www.youtube.com/watch?v=jzNmX69h_HA';
//	echo parseYouTubeId($s);
//	echo '<br><br>';
//
//	$s = 'http://www.youtube.com/watch?v=jzNmX69h_HA&feature=player_embedded';
//	echo parseYouTubeId($s);
//	echo '<br><br>';
//
//	$s = 'http://www.youtube.com/v/jzNmX69h_HA?fs=1&amp;hl=en_US';
//	echo parseYouTubeId($s);
//	echo '<br><br>';
//
//	$s = 'http://www.youtube.com/user/tgnDragonAge2#p/u/0/jzNmX69h_HA';
//	echo parseYouTubeId($s);
//	echo '<br><br>';
//
//	$s = 'http://www.youtube.com/tgnWorldOfWarcraft#p/c/FD3ACB6A1128406A/3/ZXKobFJWuyc';
//	echo parseYouTubeId($s);
//	echo '<br><br>';
//}


//==============================================================================
// VideoReadr
// videoreadr.com
// Enhance YouTube videos with bookmarks and transcripts
//
function tgn_videoreadr_script($id, $width, $height, $background)
{
	$background = str_replace('#', '%23', $background);

  return <<<EOS
<script src="http://videoreadr.com/read/$id.js?embed=true&width=$width&height=$height&background=$background&layout=transcript2" type="text/javascript"></script>
EOS;
}

function tgn_videoreadr_iframe($id, $width, $height, $background)
{
	$background = str_replace('#', '%23', $background);

  return <<<EOS
<iframe src="http://videoreadr.com/read/$id?embed=true&width=$width&height=$height&background=$background&layout=transcript2" width="$width" height="$height" scrolling="no" marginwidth="0" marginheight="0" frameborder="0"></iframe>
EOS;
}


//==============================================================================
// Utility
// Helper functions
//
// [youtube]                            -> id:default,     width:default, height:default
// [youtube=X8gBdsBjpJw]                -> id:X8gBdsBjpJw, width:default, height:default (Equals (=) is optional)
// [youtube X8gBdsBjpJw]                -> id:X8gBdsBjpJw, width:default, height:default
// [youtube X8gBdsBjpJw 200]            -> id:X8gBdsBjpJw, width:200,     height:default
// [youtube X8gBdsBjpJw height=200]     -> id:X8gBdsBjpJw, width:default, height:200
// [youtube X8gBdsBjpJw height=200 300] -> (Unsupported: shorthand values must appear before key:value pairs)
//
function tgn_parse_shortcode($defaults, $values)
{
	// commented: can do this in one loop, not two
//	$out = shortcode_atts($defaults, $values);

	$out = array();
	$values = (array)$values; // $values == '' if [shortcode] has no atributes

	reset($defaults);

	// process shorthand values first in $defaults order
	if (isSet($values[0]))
	{
		$key = key($defaults);
		$out[$key] = ltrim($values[0], '='); // first value may start with '=', eg: [youtube=X8gBdsBjpJw] -> values[0] = '=X8gBdsBjpJw'

		for ($i = 1; false !== next($defaults) && isSet($values[$i]); $i++)
		{
			$key = key($defaults);
			$out[$key] = $values[$i];
		}
	}

	// process key:value pairs next, continuing from shorthand values in $defaults order
	while (list($key, $value) = each($defaults))
	{
		$out[$key] = array_key_exists($key, $values) ? $values[$key] : $value;
	}

	return $out;
}

?>
